
package vt.cs.db;

import java.util.*;


/**
 * An AttributeObject is an abstract class which provides a 
 * table of attributes and a name. DatabaseSet, Database, and Table
 * subclass from this.
 */

public abstract class AttributeObject {
	protected	Hashtable	attributes	= null;
	protected	String		name		= null;

	public AttributeObject() {
		name = new String("Unnamed");
		attributes = new Hashtable();
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public void setAttribute(String key, String value) {
		attributes.put(key, value);
	}

	public String getAttribute(String key) {
		return (String) attributes.get(key);
	}

	public String removeAttribute(String key) {
		return (String) attributes.remove(key);
	}

	public Enumeration attributeKeys() {
		return attributes.keys();
	}
}


