package vt.cs.db.filedb;

import java.io.*;
import java.util.*;

/** 
 * A test class for the DiskFileTable class
 * Jeff Nielsen, December 1996
 */
public class Test {
    public static void main(String[] args) throws IOException {
        // Test all the public methods
        try {
            DiskFileTable dft = new DiskFileTable(args[0]);
            System.out.println("Table contains "+dft.recordCount()+" records");
            System.out.println("\nVariable names, types, and descriptions are:");
            String[] varNames = dft.variableNames();
            for (int i = 0; i < varNames.length; i++) {
                String var = varNames[i];
                System.out.println(var + " = " + dft.variableType(var) + 
                                    " : " + dft.description(var));
            }
            System.out.println("\nColumns containing Integer objects are:");
            varNames = dft.variableNames("Java.lang.Integer");
            for (int i = 0; i < varNames.length; i++)
                System.out.println(varNames[i]);

            while (true) {
                System.out.println("\nWhat value do you wish to get from the table?");
                DataInputStream din = new DataInputStream(System.in);
                String param1 = din.readLine().toUpperCase();
                String param2 = din.readLine().toUpperCase();
                int intparam1, intparam2;           
                if (param2.equals("")) {    // Only one argument
                    try {
                        intparam1 = Integer.parseInt(param1);
                        System.out.print("The record values are: ");
                        Object[] elems = dft.get(intparam1);
                        for (int i = 0; i < elems.length; i++)
                            System.out.print(elems[i] + ", ");
                    } catch(NumberFormatException exc) {
                        System.out.print("The variable values are: ");
                        Object[] elems = dft.get(param1);
                        for (int i = 0; i < elems.length; i++)
                            System.out.print(elems[i] + ", ");
                    }
                }
                else {
                    intparam1 = Integer.parseInt(param1);
                    try {
                        intparam2 = Integer.parseInt(param2);
                        System.out.println("The value is " +
                                   dft.get(intparam1, intparam2));
                    }
                    catch(NumberFormatException e) {
                        System.out.println("The value is " +
                                   dft.get(intparam1, param2));
                    }
                }
            }
        }
        catch (Exception e) { e.printStackTrace(); }
    }
}
