
package vt.cs.db.rmidb;

import java.applet.*;
import java.rmi.*;
import java.rmi.server.*;
import vt.cs.db.*;
import java.net.*;
import java.util.*;

/**
 *
 * NEED TO ADD REMOTE STORAGE OF ATTRIBUTES...
 */
public class DatabaseSetImpl extends vt.cs.db.DatabaseSet {

  private Server					server 		= null;
  private	String					host		= null;
  private	String					url			= null;
  private	RemoteDatabaseSetVector	dbVector	= null;

  public void init(String url) {
    setName(url);

    this.url = url;
    try {
      URL	tmpURL	
	= new URL("http" + url.substring(url.indexOf(":")));
      this.host = tmpURL.getHost();

      server = (Server) Naming.lookup("//" + host + "/" + Server.NAME);
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    /*
     * See if the url for this dbset exists. If it doesn't, have
     * the rmidb server create a vector for us.
     */
    try {
      dbVector = (RemoteDatabaseSetVector) Naming.lookup(url);
    }
    catch (NotBoundException nbe) {
      int		index = url.indexOf(DatabaseSet.PREFIX);
      try {
	url = server.newObject(url.substring(index), 
			       "vt.cs.db.rmidb.RemoteDatabaseSetVectorImpl");
	dbVector = (RemoteDatabaseSetVector) Naming.lookup(url);
      }
      catch (Exception e) {
	e.printStackTrace();
      }
    }
    catch (Exception e) {
      System.out.println("RMI DatabaseSet(): " + e);
    }
  }

  public void addDatabase(Database db) {
    /*
     * We need to give an error or clone the database if it isn't
     * an RMI-based db.
     */
    if (db instanceof vt.cs.db.rmidb.LocalDatabase) {
      try {
	dbVector.addElement(db.getName());
      }	
      catch (Exception e) {
	e.printStackTrace();
      }
    }
  }

  /*
   * For now we'll override our super's getDatabases since we are
   * just keeping a list of names, not a table of Database objects.
   */
  public String[] getDatabases() {
    String[]	databases	= null;
    Vector		dbvec		= null;
    int			i 			= 0;
    try {
      dbvec = dbVector.get();
      databases = new String[dbvec.size()];
      for (Enumeration e = dbvec.elements(); e.hasMoreElements();) {
	databases[i++] = (String)e.nextElement();
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
    return databases;
  }

  public Database newDatabase(String name) {
    String 			dburl		= null;
    RemoteDatabase	remotedb 	= null;
    LocalDatabase	db 			= null;
    try {
      dburl = server.newObject(Database.PREFIX + "/" + name, 
			       "vt.cs.db.rmidb.RemoteDatabaseImpl");
      remotedb = (RemoteDatabase) Naming.lookup(dburl);
      remotedb.setName(name);
      dbVector.addElement(name);
      db = new LocalDatabase(remotedb);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return db;
  }

  public synchronized Database getDatabase(String name) {
    RemoteDatabase		db 	= null;
    try {
      if (dbVector.contains(name)) {
	db = (RemoteDatabase) Naming.lookup("rmi://" + host + "/" + 
					    Database.PREFIX + "/" + name);
      }
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    if (db == null)
      return newDatabase(name);
    else
      return new LocalDatabase(db);
  }

  public void deleteDatabase(String name) {
    Database	db		= null;
    String		objName = null;
    try {
      //objName = new String("rmi://" + host + "/" + 
      //	Database.PREFIX + "/" + name);
      //db = (Database) Naming.lookup(objName);
      //db.clear();
      //Naming.unbind(objName);
      dbVector.removeElement(name);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

}


