
package vt.cs.db.rmidb;

import java.rmi.*;
import java.util.*;
import vt.cs.db.*;

public class LocalDatabase extends Database {
	public RemoteDatabase	db	= null;

	public LocalDatabase(RemoteDatabase db) {
		this.db = db;
	}

	/* ----------- Override all of the AttributeObject methods ---------- */
	public void setName(String name) {
		try {
			db.setName(name);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public String getName() {
		String	n = null;
		try {
			n = db.getName();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return n;
	}

	public void setAttribute(String key, String value) {
		try {
			db.setAttribute(key, value);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public String getAttribute(String key) {
		String	n = null;
		try {
			n = (String)db.getAttribute(key);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return n;
	}

	public String removeAttribute(String key) {
		String n = null;
		try {
			n = db.removeAttribute(key);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return n;
	}

	public Enumeration attributeKeys() {
		Enumeration keys = null;
		try {
			keys = db.attributeKeys().elements();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return keys;
	}
	/* ------------------------------------------------------------------ */

	/* -------------- Override all of the Database methods -------------- */

	public String[] getTables() {
		String	tbs[] = null;
		try {
			tbs = db.getTables();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return tbs;
	}

	public Table newTable(String name, String[] columnNames,
		String[] columnTypes, String[] columnDescriptions, String source) {

		RemoteTable	remoteTable = null;
		LocalTable	localTable	= null;

		/*
		 * Instantiate a table and add it to the (superclass's) tables table.
		 */
		try {
			remoteTable = db.newTable(name, columnNames, columnTypes,
				columnDescriptions, source);

			localTable = new LocalTable(remoteTable);
		}
		catch (Exception e) {
			e.printStackTrace();
		}

		return localTable;
	}

	public Table getTable(String name) {
		LocalTable	table 		= null;
		try {
/*
			RemoteTable	remoteTable	= null;
			remoteTable = this.db.getTable(name);
			table = new LocalTable(remoteTable);
			table = new LocalTable((RemoteTable)this.db.getTable(name));
*/
			table = new LocalTable(this.db.getTable(name));
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return table;
	}

	public void deleteTable(String name) {
		try {
			db.deleteTable(name);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		super.deleteTable(name);
	}
	
	public void clear() {
		try {
			db.clear();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		super.clear();
	}
	
	public void addTable(Table table) {
		try {
			db.addTable(((LocalTable)table).table); /* ?? */
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	/* ------------------------------------------------------------------ */

}


