
package vt.cs.db.rmidb;
 
import java.rmi.*;
import java.rmi.server.*;
import java.net.*;
import vt.cs.db.*;

public class ServerImpl extends UnicastRemoteObject implements Server {
	
	private String name = null;

	public ServerImpl(String name) throws RemoteException {
		super();
		this.name = name;
	}

	public String newObject(String name, String className) 
		throws RemoteException {
		String url = null;

		try {
			Object obj = Class.forName(className).newInstance();
			Naming.rebind(name, (Remote)obj);

			url = new String("//" +
				InetAddress.getLocalHost().getHostName() +
				"/" + name);
		}
		catch(Exception e) { 
			System.out.println(e);
		}
		
		return url;
	}

	public static void main(String args[]) {
		System.setSecurityManager(new RMISecurityManager());

		try {
			ServerImpl manager = new ServerImpl(Server.NAME);
			Naming.rebind(Server.NAME, manager);
		}
		catch (Exception e) {
			System.out.println("main(): " + e);
		}
		System.out.println("Remote Database Server started...");
	}

}
