
package vt.cs.db.simplefile;

import java.net.*;
import java.util.*;
import java.io.*;
import vt.cs.db.Database;
import vt.cs.db.Table;
import vt.cs.db.AttributeObject;

/*
 */
public class DatabaseSetImpl extends vt.cs.db.DatabaseSet {
	private String				url 		= null;
	private	FileDatabase		db			= null;

	public void init(String url) {
	//System.out.println("database URL="+url);
		this.url = url;
		setName(url);
		db = new FileDatabase(url);
	}

	public String[] getDatabases() {
		String[] dbs = new String[1];
		dbs[0] = db.getName();
		return dbs;
	}

	public Database getDatabase(String name) {
		if (name.equals(db.getName()))
			return db;
		else
			return null;
	}

	public Database newDatabase(String name) { return null; }
	public void addDatabase(Database db) {}
	public void deleteDatabase(String name) {}

	public static void readAttributes(AttributeObject obj,
		DataInputStream stream, String endOfAttrString) {
		String	line	= null;
		boolean inHeader = true;
		try {
			while (inHeader) {
				line = stream.readLine();
				if ((line == null) || (line.startsWith(endOfAttrString))) {
					inHeader = false;
				}
				else if (!line.startsWith("#")) {
					/* Should use tokenizer here... */
					int eqIdx = line.indexOf("=");
					if (eqIdx > -1) {
						obj.setAttribute(line.substring(0, eqIdx), 
							line.substring(eqIdx+1));
					}
				}
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

}

class FileDatabase extends Database {
	private URL				data 	= null;
	private DataInputStream	stream 	= null;

	public FileDatabase(String url) {
		setName(url);
		try {
		 	data = new URL(url);
			stream = new DataInputStream(data.openStream());
			DatabaseSetImpl.readAttributes(this, stream, "table");
			if (attributes.get("name") != null) {
				setName((String)attributes.get("name"));
			}
			FileTable table = new FileTable(stream);
			while (table.valid()) {	
				tables.put(table.getName(), table);
				table = new FileTable(stream);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void deleteTable(String name) {}
	public void addTable(Table table) {}
	public void clear() {}
	public Table newTable(String name, String[] columnNames,
        String[] columnTypes, String[] columnDescriptions, String source) { 
		return null; 
	}
}

class FileTable extends Table {
	private Vector     	columns 	= null;
	private	Hashtable	columnNames	= null;
	private boolean		isValid		= false;

	public FileTable(DataInputStream stream) {
		setName("(Untitled)");
		columns = new Vector();
		columnNames = new Hashtable();
		try {
			boolean endOfTable = false;

			DatabaseSetImpl.readAttributes(this, stream, "format=");
			if (attributes.get("name") != null) {
				setName((String)attributes.get("name"));
			}

			String	line	= null;

			/*
			 * The next line after "format=" should have a white-space
			 * delimited list of column names. 
			 */
			line = stream.readLine();
			if (line == null)
				return;
			StringTokenizer format = new StringTokenizer(line);
			while (format.hasMoreTokens()){
				String column = format.nextToken();
//System.out.println("parsing, column = "+column);
				columns.addElement(new Column(column, "java.lang.Long"));
				columnNames.put(column, new Integer(columns.size() - 1));
			}
			line = stream.readLine(); 
			if (line.startsWith("type")) {
				line = stream.readLine(); 
				int columnNumber = 0;
				StringTokenizer types = new StringTokenizer(line);
				while (types.hasMoreTokens()) {
					String type = "java.lang." + types.nextToken();
					((Column)(columns.elementAt(columnNumber++))).type = type;
				}
				line = stream.readLine(); 
			}

			/*
			 * Read in the data until "endformat" reached
			 */
			int		i 		= 0;
			String 	type	= null;
			while (!endOfTable) {
				line = stream.readLine();
				if (line.startsWith("endformat") || 
					line.startsWith("endtable")) {
					endOfTable = true;
				}
				else {
					StringTokenizer rowData = new StringTokenizer(line);
					i = 0;
					while (rowData.hasMoreTokens()) {
						String	elem = rowData.nextToken();
						type = ((Column)(columns.elementAt(i))).type;
						if (type.equals("java.lang.Long")) {
							((Column)(columns.elementAt(i))).data.addElement(
								new Long(elem));
						}
						else if (type.equals("java.lang.Integer")) {
							((Column)(columns.elementAt(i))).data.addElement(
								new Integer(elem));
						}
						else if (type.equals("java.lang.Double")) {
							((Column)(columns.elementAt(i))).data.addElement(
								new Double(elem));
						}
						else if (type.equals("java.lang.Float")) {
							((Column)(columns.elementAt(i))).data.addElement(
								new Float(elem));
						}
						else if (type.equals("java.lang.Boolean")) {
							((Column)(columns.elementAt(i))).data.addElement(
								new Boolean(elem));
						}
						else if (type.equals("java.lang.String")) {
							if (elem.startsWith("\"")) {
								String tmp = null;
								elem = elem.substring(1);
								while(rowData.hasMoreTokens() && 
									!elem.endsWith("\"")) {
									tmp = (String) rowData.nextElement();
									elem = elem + " " + tmp;
								}
								elem = elem.substring(0, elem.length() - 1);
							}
							((Column)(columns.elementAt(i))).data.addElement(
								new String(elem));
						}
						i++;
					}
				}
			}
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		isValid = true;
	}

	public long rowcount() {
		if (columns.size() == 0)
			return 0;
		else
			return  ((Column)(columns.elementAt(0))).data.size();
	}

	public boolean valid() {
		return isValid;
	}

	public Enumeration columnNames() {
		return columnNames.keys();
	}

	public Enumeration columnNames(String type) {
		Vector	tmp = new Vector();
		for (Enumeration e = columns.elements(); e.hasMoreElements();){
			Column col = ((Column)e.nextElement());
			if (type.equals(col.type)) 
				tmp.addElement(col.name);
		}
		return tmp.elements();
	}

	public String description(String columnName) {
		return "No desciption available";
	}

	public Object get(int rowNumber, int columnNumber) {
		return 
		  ((Column)(columns.elementAt(columnNumber))).data.elementAt(rowNumber);
	}

	public Object get(int rowNumber, String columnName) {
	//System.out.println("ColumnName = "+columnName);
		Integer	columnNumber	= null;
		columnNumber = (Integer) columnNames.get(columnName);
		return get(rowNumber, columnNumber.intValue());
	}

	public void appendRow(Object[] rowData) {}
}


class Column {
	public	String	name	= null;
	public	String	type	= null;
	public	Vector	data	= null;

	Column(String name, String type) {
		this.name = name;
		this.type = type;
		data = new Vector();
	}
}

/*
class PushBackLineInputStream extends FilterInputStream {
	private	String		line	= null;
	private	InputStream	stream	= null;

	public PushBackLineInputStream(InputStream stream) {
		lines = new Vector();
		this.stream = stream;
	}

	public String readLine() {
		if (line == null) {
			return stream.readLine();
		}
		else {
			String tmp = line;
			line = null;
			return tmp;
		}
	}

	public void unreadLine(String line) {
		this.line = line;
	}
}
*/
