
package vt.cs.db.widgets.ifc;

import netscape.application.*;
import java.util.*;
import mlsoft.mvt.*;
import vt.cs.db.*;

public class DatabaseTreeView extends MlTreeView implements Target {
	private	Thread				reader		= null;
	private	DatabaseSet			dbSet		= null;
	private	DatabaseConsumer	consumer	= null;
	private	String				source		= null;

	/* 
	 * Need to figure out how to get strings out of the tree.
	 * Until then we'll duplicate some effort and store them
	 * ourselves.
	 */
	private Vector				items		= null;
	
	public DatabaseTreeView(String dbSetSource) {
		MlResources 	res	= null;

		setHorizResizeInstruction(View.WIDTH_CAN_CHANGE);
		setVertResizeInstruction(View.HEIGHT_CAN_CHANGE);

    	setTargetAndCommand(this, "activate", "activate");
    	setTargetAndCommand(this, "selectRow", "selectRow");

		res = new MlResources();
		res.add("selectionPolicy", "SELECT_MULTIPLE_ROW");
		setValues(res);

		this.source = dbSetSource;
		update(source);
	}

	void update(String source) {
		String[]	dbs		= null;
		Database	db		= null;
		String[]	tables	= null;
		Table		table	= null;
		String		name	= null;
		int			i		= -1;
		int			j		= -1;

		items = new Vector();
		try {
			dbSet = Manager.getDatabaseSet(source);
			name = dbSet.getName();
			addRow(0, true, name);
			items.addElement(dbSet);

			dbs = dbSet.getDatabases();
			for (i = 0; i < dbs.length; i++) {
				db = dbSet.getDatabase(dbs[i]);			
				name = db.getName();
				addRow(1, true, name);
				items.addElement(db);

				tables = db.getTables();
				for (j = 0; j < tables.length; j++) {
					table = db.getTable(tables[j]);
					name = table.getName();
					addRow(2, true, name);
					items.addElement(table);

					for (Enumeration e = table.columnNames(); 
						e.hasMoreElements();) {
						name = (String)e.nextElement();
						addRow(3, false, name);
						items.addElement(new DatabaseTreeViewColumnRef(table, 
							name));
					}
				}	
			}
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}

	public void setConsumer(DatabaseConsumer consumer) {
		this.consumer = consumer;
	}

	public void performCommand(String command, Object arg) {
		MlGridCommand 	cmd 		= (MlGridCommand)arg;
		boolean			doubleClick = command.equals("activate");
		Object			selection	= items.elementAt(cmd.row);

		if (consumer != null) {
			if (selection instanceof DatabaseSet) 
				consumer.databaseSetSelected((DatabaseSet)selection, 
					doubleClick);
			else if (selection instanceof Database) 
				consumer.databaseSelected((Database)selection, doubleClick);
			else if (selection instanceof Table) 
				consumer.tableSelected((Table)selection, doubleClick);
			else if (selection instanceof DatabaseTreeViewColumnRef) 
				consumer.columnSelected(
					((DatabaseTreeViewColumnRef)selection).table, 
					((DatabaseTreeViewColumnRef)selection).columnName, 
					doubleClick);
			else
				System.out.println("Unidentified selection: " + selection);
		}
	}

}

class DatabaseTreeViewColumnRef {
	public	Table	table		= null;
	public	String	columnName	= null;

	public DatabaseTreeViewColumnRef(Table table, String columnName) {
		this.table = table;
		this.columnName = columnName;
	}
}


