/*
 * @(#)TelePointerTest.java	James "Bo" Begole
 *
 * Copyright (c) 1995 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

import vt.cs.share.*;
import java.awt.*;
import java.applet.*;


public class TelePointerTest extends Applet {
  public void init() {
    new TelePointerTestFrame();
  }

    public static void main(String args[]) {
	Frame f = new Frame("TelePointer Test");
	TelePointerTest teletest = new TelePointerTest();

	teletest.init();
	teletest.start();

	f.add("Center", teletest);
    }

}

class TelePointerTestFrame extends Frame {
  Telepointer telepointer = null;
  Telepointer telepointer2 = null;
  TextField nameField = null;
  Panel testPanel = new Panel();
  TPPanel tpPanel = new TPPanel();


  public TelePointerTestFrame() {
	super("TelePointerTestFrame");
	setLayout(null);
	resize(500, 300);
	add(telepointer = new Telepointer(
		new Participant("Bo", Color.red)));
	add(testPanel);
	testPanel.setBackground(Color.black);
	testPanel.setSize(new Dimension(30,30));

	add(tpPanel);
	tpPanel.setSize(new Dimension(40,40));

	Panel p = new Panel();
    p.setLayout(new BorderLayout());
    p.add("North",new Button("Show Name"));
    p.add("South",new Button("Hide Name"));
    p.add("Center", nameField = new TextField(20));
    p.setBounds(30,30, 100, 75);
    add(p);
	
	add(telepointer2 = new Telepointer(new 
		Participant("Craig", Color.green)));
	telepointer.setShowName(true);
	setBackground(Color.blue);
	show();
  }


	public boolean action(Event evt, Object arg) {
		if ("Show Name".equals(arg)) {
		   telepointer.setShowName(true);	
		   telepointer2.setShowName(true);	
		   return true;
		}
		if ("Hide Name".equals(arg)) {
		   telepointer.setShowName(false);	
		   telepointer2.setShowName(false);	
		   return true;
		}
		if (evt.target == nameField) {
			telepointer.getParticipant().setName(
				nameField.getText());
		   return true;
		}
	   	return false;
	}


	public void paint(Graphics g) {
	 super.paint(g);
	 // telepointer.paint(g);
	 //telepointer2.paint(g);
	}

	
  public boolean mouseMove(Event evt, int x, int y) {
/*  
      if (telepointer == null){
	  telepointer = new Telepointer(new Participant("Bo", Color.red));
	  telepointer.show();
      }

      if (telepointer2 == null) {
	telepointer2 = new Telepointer(new Participant("Craig", Color.green));
	telepointer2.show();
      }
*/      

      if (telepointer != null)
	      telepointer.move(x+10, y+10);
      if (telepointer2 != null)
      	telepointer2.move(x+25, y-25);
	  if (testPanel != null)
		  testPanel.move(x-25, y+25);
	  if (tpPanel != null)
		  tpPanel.move(x-25, y-25);
      return true;

/*
    if (evt.target instanceof Component) {
      Component tempComp = (Component)evt.target;
      telepointer.move(tempComp, x+10, y+10);
      telepointer2.move(tempComp, x+10, y-10);
      telepointer.show();
      telepointer2.show();
      return true;
    }
    return false;
    */
  }
}

class TPPanel extends Button {
	Telepointer tp = new Telepointer(new Participant("Banana", Color.yellow));

	TPPanel () {
		super("Test");
		//setLayout(null);
		//add(tp);
		tp.move(5,5);
	}
	public void update(Graphics g) {
		paint(g);
	}
	
	int counter = 0;
	public void paint(Graphics g) {
		super.paint(g);
		counter = ++counter % 10;
		tp.move(counter, counter);
		tp.paint(g);
	}
	
}


