/*
 * %W% %E%  James Bo Begole
 *
 * Copyright (c) 1997 James Begole,  All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * James Begole MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. James Begole 
 * SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 *
 * $Header: /home/nie/cvsroot/prototype/vt/cs/util/TableWriter.java,v 1.2 1997/05/16 22:31:17 begolej Exp $
 *
 */

package vt.cs.util;

/**
 *
 * @author	James "Bo" Begole
 *
 * @version $Revision $
 */


import vt.cs.db.*;

public class TableWriter extends Thread {
  Buffer buffer;
  Table table;

  public TableWriter(Table table, Buffer buffer) {
    this.buffer = buffer;
    this.table = table;
    setPriority(Thread.MIN_PRIORITY);
    this.start();
  }

  public void run() {
    while (true) {
      try {
	Object nextObj = buffer.take();
	debug("nextObj = "+nextObj);
	if (nextObj instanceof Attribute) {
	  Attribute att = (Attribute)nextObj;
	  table.setAttribute(att.getParameter(), att.getValue());
	} else
	  table.appendRow((Object[])nextObj);
      } catch (Exception e) {
	e.printStackTrace();
      }
    }
  }

  private static  final boolean debug = false;
  private void debug(String msg) {
    if (debug)
      System.out.println(getClass().getName()+": "+msg);
  }
}
