/*
 * %W% %E%  James Bo Begole
 *
 * Copyright (c) 1997 James Begole,  All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * James Begole MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. James Begole 
 * SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 *
 * $Header: /home/nie/cvsroot/prototype/vt/cs/util/VectorBuffer.java,v 1.2 1997/05/16 22:31:18 begolej Exp $
 *
 */

package vt.cs.util;

/**
 *
 * @author	James "Bo" Begole
 *
 * @version $Revision $
 */

import java.util.Vector;

public class VectorBuffer  implements Buffer {
  Vector elements = new Vector();

  public VectorBuffer() {
  }

  public int getCount() {
    return elements.size();
  }

  public synchronized void put(Object obj) {
    elements.addElement(obj);

    if (elements.size() == 1)
      notifyAll();
  }

    public synchronized Object take() {
    while (elements.size() == 0) // wait until not empty
      try {
	wait();
      } catch (InterruptedException ex) {
	ex.printStackTrace();
      }

      Object tempObj = elements.firstElement();
      elements.removeElement(tempObj);

      return tempObj;
    }

}
