/*
 *
 * Written By:   Philip Isenhour
 * Date:         25 September 1996
 * Description:  Prototype Link view class.
 *
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/client/LinkView.java,v 1.4 1997/02/19 19:43:33 begolej Exp $
 *
 * Copyright (c) 1996 Philip Isenhour
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */
 
package vt.cs.virtSchool.client;
 
import netscape.application.*;
import netscape.util.*;
import vt.cs.virtSchool.server.*;

/**
 * A LinkView represents a link between two instantated activities. It
 * is only responsible for drawing a handle which the user may click
 * to delete the link. 
 *
 * @version $Id: LinkView.java,v 1.4 1997/02/19 19:43:33 begolej Exp $
 */
public class LinkView extends View {
	public static final int HANDLE_SIZE = 5;

	private	ActivityView	act1 	= null;
	private	ActivityView	act2 	= null;
	private Link			link	= null;

	public LinkView(Link link, ActivityView act1, ActivityView act2) {
		super();
		this.link = link;
		this.act1 = act1;
		this.act2 = act2;
		setBounds(0, 0, HANDLE_SIZE, HANDLE_SIZE);
		draw();
	}

	public void drawView(Graphics g) {
		g.setColor(Color.black);
		g.fillRect(0, 0, width(), height());
	}

	public Point act1Center() {
        int act1x = act1.bounds().midX();
        int act1y = act1.bounds().midY();
		return new Point(act1x, act1y);
	}

	public Point act2Center() {
        int act2x = act2.bounds().midX();
        int act2y = act2.bounds().midY();
		return new Point(act2x, act2y);
	}

	public void mouseUp(MouseEvent event) {
		((TableView)superview()).removeLink(link);
	}

	public boolean mouseDown(MouseEvent event) {
		return true;
	}
}


