package vt.cs.virtSchool.labapplets.BlockAndPlane;
import java.awt.*;

class SimCanvas extends Canvas {
	// Units of pixel / meter
     public static final float ScaleFactor = 100;
     private Plane plane1;
     private Plane plane2;     
  private Plane floor;     
  private MovingBody MB;
  Dimension offDimension;
  Image     offImage;
  Graphics  offGraphics;
  SimCanvas(Plane p1, Plane p2, Plane f, MovingBody MovBod){
    plane1 = p1;
    plane2 = p2;
    floor  = f;
    MB  = MovBod;
  }
  public void update(Graphics g) {
    Dimension d = size();
    if ( (offGraphics == null) || (d.width != offDimension.width) || (d.height != offDimension.height) ) {
      offDimension = d;
      offImage = createImage(d.width, d.height);
      offGraphics = offImage.getGraphics();
      offGraphics.setFont(g.getFont());
      MB.reset();
    }

    offGraphics.setColor(Color.black);
    offGraphics.fillRect(0,0,d.width,d.height);
  		  		
    offGraphics.setColor(Color.red);
    plane1.paint(offGraphics, d);
    plane2.paint(offGraphics, d);		
    MB.paint(offGraphics, d);
    floor.paint(offGraphics, d);
    // Draw in Floor as a line
    offGraphics.drawLine(Math.round(ScaleFactor*plane1.getRightEnd()),d.height-1,Math.round(ScaleFactor*(plane1.getRightEnd()+floor.getLength())),d.height-1);
		
    g.drawImage(offImage, 0, 0, null);		
  }
  public Dimension minimumSize() {
    return new Dimension(500, 250);
  }
  public Dimension preferredSize() {
    return minimumSize();
  }
  public void paint(Graphics g) {
    update(g);
  }
} 
