/**
  NAME:         NeedleDemo.java
                Copyright (c) 1996 Liam Relihan. All rights reserved.
  PURPOSE:      This applet tests out the Needle.class needle gauge class.

  AUTHOR:       Liam Relihan
                <relihanl@ul.ie>
  SCCS:         %M%        %R%.%L% %D%
  DATE:         15-May-1996
  PARAMETERS:   
  CALLED BY:
  MODIFIED:     
  BUGS:         
 */
package vt.cs.virtSchool.labapplets.Meter;

import java.awt.*;
import java.lang.*;
import java.applet.*;
import vt.cs.widgets.*; 

public class NeedleDemo extends Applet implements Runnable {
  Needle needle1,needle2,needle3;
  Thermometer thermometer1;
  private Thread life = null;

  
  public static void main(String args[]) {
    Frame frame = new Frame("LevelGaugeDemo");
    NeedleDemo needleDemo = new NeedleDemo();
    needleDemo.init();
    needleDemo.start();
    
    frame.add("Center", needleDemo);
    frame.resize(450, 160);
    frame.show();
  }
  
  public void init() { 
    setLayout(new GridLayout(1, 2));
    needle1 = new Needle(0.0,
			 300.0,
			 50.0,
			 45.0);
    
    needle1.setZone("cyanzone",100.0,200.0,Color.cyan);

    needle1.setZone("bluezone",200.0,250.0,Color.blue);
    
    needle1.setZone("redzone",250.0,300.0,Color.red);
    
    needle1.setNumbersFont(new Font("Helvetica", Font.PLAIN, 9));
    
    
    needle1.setCaption("Bogon Level");
    add(needle1);
    
    needle2 = new Needle(-10.0,
			 10.0,
			 2.0,
			 2.3);
    
    needle2.setCaptionFont(new Font("Times", Font.PLAIN, 20));
    
    needle2.setCaption("Subsonic Balance");
    add(needle2);
    
    needle3 = new Needle(-500.0,
			 500.0,
			 100.0,
			 0.0);

    needle3.setZone("safezone",-100,100.0,Color.green);

    needle3.setZone("negative_redzone",-500.0,-100.0,Color.red);

    needle3.setZone("positive_redzone",100.0,500.0,Color.red);

    needle3.setNumbersFont(new Font("Helvetica", Font.PLAIN, 8));

    needle3.setCaption("Core Emission");

    add(needle3);
    
    thermometer1 = new Thermometer(0.0,
				   100.0,
				   10.0,
				   0.0);

    thermometer1.setCaption("Core Temperature");

    add(thermometer1);
  }
  

  public void start(){
    life = new Thread(this);
    life.start();
  }
 

  public void stop() { life.stop(); }

  
  double randomNum(double low, double high){
    return (double) (low + Math.random() * (high - low));
  }

  
  public void run(){
    int i = 0;
    while (true) {
      try {
	Thread.sleep(30);
      }
      catch (InterruptedException e) {
	return;
      }
      needle1.setValue(needle1.getValue() + randomNum(-10, 10));
      
      needle2.setValue(needle2.getValue() + randomNum(-1, 1));
      
      needle3.setValue(needle3.getValue() + randomNum(-25, 25));

      thermometer1.setValue(thermometer1.getValue() + randomNum(-5, 5));
    }
  }  
}








