
//
//	InspectorController.java
//
//	Copyright 1996,	Black Diamond Software.	 All rights reserved.
//
//	Written	by: Jason Beaver and Tyler Gingrich
//

package	vt.cs.virtSchool.labapplets.WhiteBoard;

import netscape.application.*;
import netscape.util.*;

public class InspectorController extends Object	implements Target {
	InternalWindow inspectorWindow;
	ColorWell strokeColorWell;
	ColorWell fillColorWell;
	Button filledStateButton;
	DrawController currentDrawController;

	public InspectorController(RootView root) {
		super();

		// Create the inspector	window and its contents...
		inspectorWindow	= new InternalWindow(48,5,125,195);
		inspectorWindow.setRootView(root);
		inspectorWindow.setTitle("Inspector");

		TextField strokeTitle =	new TextField(5,5,100,18);
		strokeTitle.setBorder(null);
		strokeTitle.setBackgroundColor(Color.lightGray);
		strokeTitle.setEditable(false);
		strokeTitle.setStringValue("Stroke Color");
		inspectorWindow.contentView().addSubview(strokeTitle);

		strokeColorWell	= new ColorWell(5,22,112,30);
		strokeColorWell.setColor(Color.black);
		strokeColorWell.setTarget(this);
		strokeColorWell.setCommand("strokeColorChanged");
		inspectorWindow.contentView().addSubview(strokeColorWell);

		TextField fillTitle = new TextField(5,57,100,18);
		fillTitle.setBorder(null);
		fillTitle.setBackgroundColor(Color.lightGray);
		fillTitle.setEditable(false);
		fillTitle.setStringValue("Fill Color");
		inspectorWindow.contentView().addSubview(fillTitle);

		fillColorWell =	new ColorWell(5,74,112,30);
		fillColorWell.setColor(Color.white);
		fillColorWell.setTarget(this);
		fillColorWell.setCommand("fillColorChanged");
		inspectorWindow.contentView().addSubview(fillColorWell);

		filledStateButton = Button.createCheckButton(5,109,100,16);
		filledStateButton.setTitle("Filled");
		filledStateButton.setTarget(this);
		filledStateButton.setCommand("filledStateChanged");
		inspectorWindow.contentView().addSubview(filledStateButton);

		Button moveToBackButton	= new Button(5,130,36,36);
		moveToBackButton.setBordered(true);
		//moveToBackButton.setImage(Bitmap.bitmapNamed("MoveToBack.gif"));
		moveToBackButton.setImage(vt.cs.virtSchool.client.Environment.getBitmap("MoveToBack.gif"));
		moveToBackButton.setTarget(this);
		moveToBackButton.setCommand("moveToBack");
		inspectorWindow.contentView().addSubview(moveToBackButton);

		Button moveToFrontButton = new Button(45,130,36,36);
		moveToFrontButton.setBordered(true);
		//moveToFrontButton.setImage(Bitmap.bitmapNamed("MoveToFront.gif"));
		moveToBackButton.setImage(vt.cs.virtSchool.client.Environment.getBitmap("MoveToFront.gif"));
		moveToFrontButton.setTarget(this);
		moveToFrontButton.setCommand("moveToFront");
		inspectorWindow.contentView().addSubview(moveToFrontButton);

		inspectorWindow.setBuffered(true);
		inspectorWindow.setCanBecomeMain(false);
		inspectorWindow.show();
	}

	// Sent	by when	the user manipulates one of the	inspector's components
	public void performCommand(String command,Object object) {
		if (command.equals("strokeColorChanged"))
			currentDrawController.strokeColorChanged();
		else if	(command.equals("fillColorChanged"))
			currentDrawController.fillColorChanged();
		else if	(command.equals("filledStateChanged"))
			currentDrawController.filledStateChanged();
		else if	(command.equals("moveToBack"))
			currentDrawController.moveToBack();
		else if	(command.equals("moveToFront"))
			currentDrawController.moveToFront();
	}

	// Accessor methods...

	// Would be used if you	had multiple draw windows...
	public void setCurrentDrawController(DrawController aController) {
		currentDrawController =	aController;
	}

	public void setStrokeColor(Color aColor) {
		strokeColorWell.setColor(aColor);
	}

	public Color strokeColor() {
		return strokeColorWell.color();
	}

	public void setFillColor(Color aColor) {
		fillColorWell.setColor(aColor);
	}

	public Color fillColor() {
		return fillColorWell.color();
	}

	public void setFilledState(boolean flag) {
		filledStateButton.setState(flag);
	}

	public boolean filledState() {
		return filledStateButton.state();
	}
}

