/*
 *
 * Written By:   Philip Isenhour
 * Date:         November 1996
 * Description:  Class for serializing objects into JSDA messages.
 *
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/client/RoomView.java,v
1.4 1997/01/07 20:52:58 isenhour Exp $
 *
 * Copyright (c) 1996 Philip Isenhour
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */

package vt.cs.virtSchool.server;

import java.io.*;
import SharedData.*;

/**
 * Class for serializing objects into JSDA messages.
 *
 * @version $Id Exp $
 */
public class Message implements Serializable {
	public static final int	ACTIVITY_MOVE	= 0;
	public static final int	ACTIVITY_ADD	= 1;
	public static final int	ACTIVITY_REMOVE	= 2;
	public static final int LINK_ADD		= 3;
	public static final int LINK_REMOVE		= 4;

	public static final int CHAT_TEXT		= 5;

	public 	int		type	= -1;
	public	Object	data	= null;
	public	String	source	= "";

	public Message(int type, Object data) {
		this.type = type;
		this.data = data;
	}

	public static Message messageFromByteArray(byte[] data) {
		ByteArrayInputStream	byteArrayStream = null;
		ObjectInputStream		objectStream	= null;
		Message					msg				= null;

		try {
			byteArrayStream = new ByteArrayInputStream(data);
			objectStream = new ObjectInputStream(byteArrayStream);

			msg = (Message)objectStream.readObject();
		}
		catch(Exception e) {
			e.printStackTrace();
		}

		return msg;
	}

	public static Message messageFromData(Data data) {
		return messageFromByteArray(data.getData());
	}

	public static byte[] toByteArray(Object obj) {
		ByteArrayOutputStream	byteArrayStream = null;
		ObjectOutputStream		objectStream	= null;
		byte[]					bytes			= null;

		try {
			byteArrayStream = new ByteArrayOutputStream();
			objectStream = new ObjectOutputStream(byteArrayStream);

			objectStream.writeObject(obj);
			bytes = byteArrayStream.toByteArray();
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		return bytes;
	}

	public Data toData() {
		return new Data(toByteArray(this));
	}

}

